ICode9

精准搜索请尝试: 精确搜索
首页 > 其他分享> 文章详细

Open CasCade中的几种类型转换(转)

2022-05-14 09:02:39  阅读:236  来源: 互联网

标签:类型转换 Handle trimmed -- surface CasCade Geom Surface Open


1. 将Geom_BSplineSurface转化成TopoDS_Face:

Handle_Geom_BSplineSurface BSurface;
BRep_Builder builder;
TopoDS_Face Face;
builder.MakeFace(Face,BSurface,Tolerance);
2.将TopoDS_Face 转化为Geom_Surface:

Handle_Geom_Surface currentSur;
TopExp_Explorer Ex;
Ex.Init(shape,TopAbs_FACE);
TopoDS_Face currentVt = TopoDS::Face(Ex.Current());
currentSur = BRep_Tool::Surface(currentVt);
3.普通曲线转化为NURBS曲线:

Handle(Geom_Curve) ResCurve ;
Handle(Geom_TrimmedCurve) myTrimmed = new Geom_TrimmedCurve(ResCurve, 0, 1);
NurbsCurve = GeomConvert::CurveToBSplineCurve(myTrimmed); //必须指定曲线的类型如Geom_TrimmedCurve
OCC的说明如下:

-- Purpose : This function converts a non infinite curve from

-- Geom into a B-spline curve.C must be an ellipse or a

-- circle or a trimmed conic or a trimmed line or a Bezier

-- curve or a trimmed Bezier curve or a BSpline curve or a

-- trimmed BSpline curve or an OffsetCurve. The returned B-spline is

-- not periodic except if C is a Circle or an Ellipse.

4. Geom_Surface 转 Geom_BsplineSurface

GeomConvert::SurfaceToBSplineSurface(surface)
其中surface必须为Geom_Surface 中的某一具体类型

OCC的说明如下:

--- Purpose : This algorithm converts a non infinite surface from Geom

-- into a B-spline surface.

-- S must be a trimmed plane or a trimmed cylinder or a trimmed cone

-- or a trimmed sphere or a trimmed torus or a sphere or a torus or

-- a Bezier surface of a trimmed Bezier surface or a trimmed swept

--surfacewith a corresponding basis curve which can be turned into

-- a B-spline curve

5. 点云转 Geom_BsplineSurface

Handle_Geom_BSplineSurface CMiniCADTool::BuildSurface(const TColgp_SequenceOfXYZ& seqOfXYZ)
{
// Build the surface:
// points are projected on plane z = 0
// the projection vector for each point is computed
// These data give the input constraints loaded into plate algorithm

const Standard_Integer nbPnt = seqOfXYZ.Length();
Standard_Integer i;

//Filling plate
Plate_Plate myPlate;
for (i=1; i<= nbPnt; i += 4) {
gp_Vec aVec(0., 0., seqOfXYZ.Value(i).Z());
gp_XY pntXY(seqOfXYZ.Value(i).X(),seqOfXYZ.Value(i).Y());
Plate_PinpointConstraint PCst( pntXY,aVec.XYZ() );
myPlate.Load(PCst); // Load a pinpoint constraint
}
myPlate.SolveTI(2, 1.); // Solving plate equations
if (!myPlate.IsDone()) {
return Handle(Geom_BSplineSurface)();
}

// Computation of plate surface
gp_Pnt Or(0,0,0.);
gp_Dir Norm(0., 0., 1.);
Handle(Geom_Plane) myPlane = new Geom_Plane(Or, Norm);// Plane of normal Oz
Handle(GeomPlate_Surface) myPlateSurf = new GeomPlate_Surface(myPlane, myPlate);//plate surface

GeomPlate_MakeApprox aMKS(myPlateSurf, Precision::Approximation(), 4, 7, 0.001, 0);//bspline surface
return aMKS.Surface();

}
6.surface 向Geom_Plane 向下转换(DownCast方法)其中Geom_Plane类中有方法可以将gp_Pln和Geom_Plane进行相互转化。

Handle(Geom_Plane) aPlane = Handle(Geom_Plane)::DownCast(BRep_Tool::Surface(SelectFace));
PlaneOfTheView = aPlane->Pln();
7.TopoDS_Shape 向相应的格式转

例如:

Vertex = TopoDS::Vertex(Shape);
8.TopoDS_Vertex向gp_Pnt转

gp_Pnt P = BRep_Tool::Pnt(Vertex)
————————————————
版权声明:本文为CSDN博主「醉逍遥_祥」的原创文章,遵循CC 4.0 BY-SA版权协议,转载请附上原文出处链接及本声明。
原文链接:https://blog.csdn.net/qq_35097289/article/details/103816707

标签:类型转换,Handle,trimmed,--,surface,CasCade,Geom,Surface,Open
来源: https://www.cnblogs.com/mrliu0515/p/16269068.html

本站声明: 1. iCode9 技术分享网(下文简称本站)提供的所有内容,仅供技术学习、探讨和分享;
2. 关于本站的所有留言、评论、转载及引用,纯属内容发起人的个人观点,与本站观点和立场无关;
3. 关于本站的所有言论和文字,纯属内容发起人的个人观点,与本站观点和立场无关;
4. 本站文章均是网友提供,不完全保证技术分享内容的完整性、准确性、时效性、风险性和版权归属;如您发现该文章侵犯了您的权益,可联系我们第一时间进行删除;
5. 本站为非盈利性的个人网站,所有内容不会用来进行牟利,也不会利用任何形式的广告来间接获益,纯粹是为了广大技术爱好者提供技术内容和技术思想的分享性交流网站。

专注分享技术,共同学习,共同进步。侵权联系[81616952@qq.com]

Copyright (C)ICode9.com, All Rights Reserved.

ICode9版权所有